// This software was written by Gregory L Montgomery
// and is completely covered by the 
// GPL General Public License

// Date of release 1/7/1998 

// Programmer Gregory Montgomery

// This is the .C file for the mux  CLASS
#ifdef FOO
	#include <conio.h>
#endif
#include <iostream.h>
#include <stdlib.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>

#include "mux.h"

                      
/////////////////////////////////////////////////////////////////
// The mux class                                            //
//                 This is an abstract class                   //
/////////////////////////////////////////////////////////////////

// ----------------------------------------------------------- */
// constructors                                                */

// Default Port mux
mux::mux() {

    if ((mux_Port = open("/dev/Port5", O_RDWR)) == -1) {
          cerr << "Error opening Device Port Number 5\n";
          exit(1);
    } 

}


// Open the designated Port
mux::mux(const int Port) {

    switch (Port){
       case 1 : if ((mux_Port = open("/dev/Port1", O_RDWR)) == -1) {
                   cerr << "Error opening Device Port Number 1\n";
                   exit(1);
                } 
       case 2 : if ((mux_Port = open("/dev/Port2", O_RDWR)) == -1) {
                   cerr << "Error opening Device Port Number 2\n";
                   exit(1);
                }
       case 3 : if ((mux_Port = open("/dev/Port3", O_RDWR)) == -1) {
                   cerr << "Error opening Device Port Number 3\n";
                   exit(1);
                } 
       case 4 : if ((mux_Port = open("/dev/Port4", O_RDWR)) == -1) {
                   cerr << "Error opening Device Port Number 4\n";
                   exit(1);
                }
       case 5 : if ((mux_Port = open("/dev/Port5", O_RDWR)) == -1) {
                   cerr << "Error opening Device Port Number 5\n";
                   exit(1);
                } 
       case 6 : if ((mux_Port = open("/dev/Port6", O_RDWR)) == -1) {
                   cerr << "Error opening Device Port Number 6\n";
                   exit(1);
                }
       case 7 : if ((mux_Port = open("/dev/Port7", O_RDWR)) == -1) {
                   cerr <<"Error opening Device Port Number 7\n";
                   exit(1);
                } 
       case 8 : if ((mux_Port = open("/dev/Port8", O_RDWR)) == -1) {
                   cerr << "Error opening Device Port Number 8\n";
                   exit(1);
                }
       case 9 : if ((mux_Port = open("/dev/Port9", O_RDWR)) == -1) {
                   cerr << "Error opening Device Port Number 9\n";
                   exit(1);
                } 
       case 10 : if ((mux_Port = open("/dev/Port10", O_RDWR)) == -1) {
                   cerr << "Error opening Device Port Number 10\n";
                   exit(1);
                }
       case 11 : if ((mux_Port = open("/dev/Port11", O_RDWR)) == -1) {
                   cerr << "Error opening Device Port Number 11\n";
                   exit(1);
                } 
       case 12 : if ((mux_Port = open("/dev/Port12", O_RDWR)) == -1) {
                   cerr << "Error opening Device Port Number 12\n";
                   exit(1);
                }
       case 13 : if ((mux_Port = open("/dev/Port13", O_RDWR)) == -1) {
                   cerr << "Error opening Device Port Number 13\n";
                   exit(1);
                }
       case 14 : if ((mux_Port = open("/dev/Port14", O_RDWR)) == -1) {
                   cerr << "Error opening Device Port Number 14\n";
                   exit(1);
                } 
       case 15 : if ((mux_Port = open("/dev/Port15", O_RDWR)) == -1) {
                   cerr << "Error opening Device Port Number 15\n";
                   exit(1);
                }
    }
}

//-----------------------------------------------------------/
// destructor Virtual : Every class that inherits from this will have to 
// declare a destructor like it or not. 

mux::~mux(){
    close(mux_Port);
}


//-----------------------------------------------------------
// A simple function to reset ad 
void mux::Reset(){

    unsigned char temp;

    temp = mux_channel & 127;
    write(mux_Port,&temp,1);
    temp = mux_channel | 128;
    write(mux_Port,&temp,1);
}

//------------------------------------------------------------
// Change channel
void mux::Select(const int Port){

  if((Port <= 0) || (Port >= 15))
    return;

  mux_channel = (unsigned char) Port;
  Reset();
}
